Wlan.term()
white = Color.new(255, 255, 255)
green = Color.new(0,200,0)
black = Color.new(0,0,0)
blue = Color.new(0,0,200)
offscreen = Image.createEmpty(480, 272)
offscreen:clear(Color.new(0, 0, 0))
y = 0
x = 0
slist={}
lengths={}
selected=1
chosen=false
quit=false
state=0
phase=1
length=""

-- init WLAN and choose connection config
Wlan.init()
configs = Wlan.getConnectionConfigs()

--Taken from PSP-HTTPD
function string.endsWith(String,End)
  return End=='' or string.sub(String,-string.len(End))==End
end

--Taken from LUAPlayer.org
function GETIPADDRESS()
  thestr = {}
  IP = ""
  a=1
  b=1
  ipgetsock, error = Socket.connect("216.99.213.74", 80)
  while not ipgetsock:isConnected() do System.sleep(100) end
  bytesSent = ipgetsock:send("GET /ipaddress.html HTTP/1.0\r\n")
  bytesSent = ipgetsock:send("host: ww1.nia-nia.com\r\n\r\n")

  while true do
    thestr[a] = ipgetsock:recv()
    if placefound == nil then placefound = string.find(thestr[a], "REMOTE_ADDR=") end
    if placefound then placefound=placefound+12
      while true do
        if string.sub(thestr[a], placefound, placefound) == "R" then IP=string.sub(IP, 1, string.len(IP)-1) return IP end
        IP=IP..string.sub(thestr[a], placefound, placefound)
        placefound=placefound+1
      end
    end
    placefound=nil
    if Controls.read():start() then screen.waitVblankStart(10) break end
    screen.waitVblankStart()
    a=a+1
  end
  return -1
end

--Taken from PSP-HTTPD
function graphicsPrint(text)
  if y > 272 then
    offscreen:clear(Color.new(0, 0, 0))
    y = 0
  end
  for i = 1, string.len(text) do
    char = string.sub(text, i, i)
    if char == "\n" then
      y = y + 8
      x = 0
    elseif char ~= "\r" then
      offscreen:print(x, y, char, white)
      x = x + 8
      if x > 480 then
        y = y + 8
        x = 0
      end
    end
  end
  screen:blit(0, 0, offscreen)
  screen.waitVblankStart()
  screen.flip()
end

function updateConnections()
  local i=1
  for key, value in configs do
    offscreen:print(13,i*8,"  [".. i .. "]: " .. value, white)
    screen:blit(0, 0, offscreen)
    screen.waitVblankStart()
    screen.flip()
    if i == selected then
      color = green
    else
      color = white
    end
    offscreen:print(0,i*8,"->",color)
    i = i+1
  end
end

function parse()
  for j=1,table.getn(slist) do
    names[j]=string.sub( slist[j],string.find(slist[j],"net/(.+)")+3)
    graphicsPrint("  "..names[j].."\n")
  end
end

function choose()
  for i=1,table.getn(names) do
    if i == selected then
      color = green
    else
      color = white
    end
    offscreen:print(0,(i-1)*8,"->",color)
    --i = i+1
  end
end

function searchXMLFile()
    i=1
    filename = "podcast_loungeacts.xml"
    xmlfile = io.open(filename,"r")
    if xmlfile then
  offscreen:clear(black)
  repeat
    if line ~= nil then
      if string.find(line,"(.+)http(.+)%.mp3") ~= nil then
      url = string.sub( line, string.find(line,"http(.+)") )
      url2 = string.sub( url, 0,string.find(url,"%.mp3\"")) .. "mp3"
      slist[i]=url2
  length = string.sub( line,string.find( line,"length=(.+)")+8)
  length = string.sub(length,0,string.find( length," ")-2)
  --graphicsPrint("Length: " .. length .. "\n")
  --System.sleep(1000)
  lengths[i] = length
  length=""
      i=i+1
      else
      --graphicsPrint("looking\n")
      end
    end
    line = xmlfile:read()
  until line == nil
  --xmlfile:close()
    end
end

function writeIndex()
  index = "ms0:/index.html"
  indout = io.open(index,"w")

  if indout then
    indout:write("<html><head><title>PSP WebServer</title></head>\n")
    indout:write("<body><h2>WOXY Podcast Listing -via PSP</h2>\n")
    for w=1,table.getn(slist) do
      indout:write("<a href='" .. slist[w] .. "'> " .. slist[w] .. " </a><br />")
    end
    indout:write("</body></html>")
    indout:close()
  end

end

function getFile(url)
  graphicsPrint("\nget file: ")
  server="xalt.vo.llnwd.net"
  ip="68.142.72.29"
  filename="ms0:/psp/music/" ..string.sub( slist[selected],string.find(slist[selected],"loungeact/(.+)")+10)
  --graphicsPrint(" " .. ip .. names[selected] .. "\n")
  --graphicsPrint("Length: " .. length .. "\n")
  x=0
  y=0
  offscreen:clear(black)
  graphicsPrint("Connecting to file: " .. names[selected] .. "...")
    socket, error = Socket.connect(ip, 80)
    while not socket:isConnected() do
        if tries > 200 then
          quit = true
          break
        end
        tries = tries+1
    System.sleep(100) 
    end
  graphicsPrint("success!\n")
  offscreen:print(209,130, tostring(tonumber((lengths[selected]))/1024/1000) .." megabytes left",green)
  screen:blit(0, 0, offscreen)
  screen.waitVblankStart()
  screen.flip()
  local outf=io.open(filename,"w")
  if outf then
    bytesSent = socket:send("GET "..names[selected].." HTTP/1.0\r\n")
    bytesSent = socket:send("host: "..server.."\r\n\r\n")

    -- read and display result
    size = 0
    large = ""
    bufsize=1024*8
    while true do
      -- read from test page
      buffer = socket:recv()
      if string.len(buffer) > 0 then
        --graphicsPrint(".")
        size=size+string.len(buffer)
        large = large .. buffer
        if string.len(large) > bufsize then
          outf:write(large)
          large = ""
          offscreen:clear(black)
          offscreen:print(209,130, tostring(tonumber((lengths[selected])-size)/1024/1000) .." megabytes left",green)
          screen:blit(0, 0, offscreen)
          --screen.waitVblankStart()
          screen.flip()
        end
      end
      if Controls.read():start() then break end
    end
    if string.len(large) > 0 then
      outf:write(large)
    end
    outf:close()
  else
    graphicsPrint("out file error\n")
  end
end

function getState()
  if phase==1 then
    offscreen:print(13,60,"WOXY LoungeActs Podcast LUA Demo - by modsyn",green)
    offscreen:print(13,70,"Choose your network connection and hit X", green)
    offscreen:print(13,80,"Start will quit", green)
    --offscreen:print(13,100,"Selected: " .. selected, green)
    screen:blit(0, 0, offscreen)
    screen.waitVblankStart()
    screen.flip()
    lim=table.getn(configs)
  else
    lim=table.getn(names)
  end
  local pad = Controls.read()
  if pad ~= oldPad then
    if pad:cross() then
      chosen = true
    elseif pad:start() then
      quit = true
    elseif pad:down() then
      if selected < lim then
        selected = selected+1
      end
    elseif pad:up() then
      if selected > 1 then
        selected = selected-1
      end
    end
  end
  oldPad = pad
end

repeat
  state = getState()
  screen:blit(0, 0, offscreen)
  screen.waitVblankStart()
  screen.flip()

  updateConnections()
  if state == 1 then
    chosen = true  
  end
  if quit then
    break
  end

until chosen

if not quit then
  tries = 0
  offscreen:clear(black)
  graphicsPrint("Starting Network: wait...will timeout if no connection\n")
  Wlan.useConnectionConfig(selected)
  socket, error = Socket.connect("72.3.131.29", 80)
  while not socket:isConnected() do
      --graphicsPrint("Waiting: "..tries.."\n")
      if tries > 100 then
        quit = true
        break
      end
      tries = tries+1
  System.sleep(100) 
  end

  if quit then
    offscreen:clear(black)
    graphicsPrint("Couldn't connect, exiting!!!\n");
    Wlan.term()
    System.sleep(1000)
  else
    offscreen:clear(black)
    graphicsPrint("Downloading podcast XML file\n")
    -- send request
    bytesSent = socket:send("GET /podcast_loungeacts.xml HTTP/1.0\r\n")
    bytesSent = socket:send("host: www.woxy.com\r\n\r\n")

    -- read and display result
    large = ""
    small = 0
    while true do
      -- read from test page
      buffer = socket:recv()
      if string.len(buffer) > 0 then
    large = large .. buffer
    graphicsPrint("..")
      else
    small = small+1
    if small > 50 then
          break
    end
      end
      if Controls.read():start() then break end
      screen:blit(0, 0, offscreen)
      screen.waitVblankStart()
      screen.flip()
    end

    --Wlan.term()
    filename = "podcast_loungeacts.xml"
    xmlfile = io.open(filename,"w")
    if xmlfile then
      xmlfile:write(large)
    else
      graphicsPrint("Couldn't open up file...\n")
    end

    if xmlfile then
       xmlfile:close()
    end
    phase=2

    searchXMLFile()
    names={}
    chosen=false
    selectex=1
    x=0
    y=0
    parse()
    writeIndex()
    repeat
      state = getState()
      screen:blit(0, 0, offscreen)
      screen.waitVblankStart()
      screen.flip()

      choose()
      if state == 1 then
        chosen = true  
      end
      if quit then
        break
      end
    until chosen

    offscreen:clear(black)
    offscreen:print(0,0,"You chose "..names[selected].."!",green)
    screen:blit(0, 0, offscreen)
    screen.waitVblankStart()
    screen.flip()
    if not quit then
	getFile(slist[selected]) 
	while true do
		if Controls.read():start() then break end
	end
    else
	offscreen:clear(black)
	x=0
	y=0
	graphicsPrint("Download aborted...closing")
	System.sleep(2000)
    end
  end
end
Wlan.term()