white = Color.new(255, 255, 255)
green = Color.new(0,200,0)
black = Color.new(0,0,0)
os = Image.createEmpty(480, 272)
os:clear(black)
selected=1
chosen=false
state=0
quit=false
Wlan.init()
configs = Wlan.getConnectionConfigs()
y=0
x=0

--Taken from PSP-HTTPD
function graphicsPrint(text)
  if y >= 272 then
    os:clear(Color.new(0, 0, 0))
    y = 0
  end
  for i = 1, string.len(text) do
    char = string.sub(text, i, i)
    if char == "\n" then
      y = y + 8
      x = 0
    elseif char ~= "\r" then
      os:print(x, y, char, white)
      x = x + 8
      if x > 480 then
        y = y + 8
        x = 0
      end
    end
  end
  screen:blit(0, 0, os)
  screen.waitVblankStart()
  screen.flip()
end

function clear()
    os:clear(Color.new(0, 0, 0))
end

function chooseNetwork()
  Wlan.term()

  -- init WLAN and choose connection config

  repeat
    getState()
    updateConnections()
    if quit then
      break
    end
  until state==1
  Wlan.init()
  if not quit then
    Wlan.useConnectionConfig(selected)
  end
end

function updateConnections()
  local i=1
  for key, value in configs do
    os:print(13,i*8,"  [".. i .. "]: " .. value, white)
    screen:blit(0, 0, os)
    screen.waitVblankStart()
    screen.flip()
    if i == selected then
      color = green
    else
      color = white
    end
    os:print(0,i*8,"->",color)
    i = i+1
  end
end

function getState()
  os:print(13,60,"Choose your Network Connection",green)
  os:print(13,68,"drop in wifi config",green)
  screen:blit(0, 0, os)
  screen.waitVblankStart()
  screen.flip()
  lim=table.getn(configs)
  local pad = Controls.read()
  if pad ~= oldPad then
    if pad:cross() then
      state=1
    elseif pad:start() then
      quit = true
    elseif pad:down() then
      if selected < lim then
        selected = selected+1
      end
    elseif pad:up() then
      if selected > 1 then
        selected = selected-1
      end
    end
  end
  oldPad = pad
  return 0
end

--Taken from LUAPlayer.org
function GETIPADDRESS()
  tries =0
  thestr = {}
  IP = ""
  a=1
  b=1
  ipgetsock, error = Socket.connect("216.99.213.74", 80)
  while not ipgetsock:isConnected() do System.sleep(100) end
  bytesSent = ipgetsock:send("GET /ipaddress.html HTTP/1.0\r\n")
  bytesSent = ipgetsock:send("host: ww1.nia-nia.com\r\n\r\n")

  while true do
    thestr[a] = ipgetsock:recv()
    if placefound == nil then placefound = string.find(thestr[a], "REMOTE_ADDR=") end
    if placefound then placefound=placefound+12
      while true do
        if string.sub(thestr[a], placefound, placefound) == "R" then IP=string.sub(IP, 1, string.len(IP)-1) return IP end
        IP=IP..string.sub(thestr[a], placefound, placefound)
        placefound=placefound+1
        if tries > 100 then
          break
        end
    tries = tries+1
      end
    end
    placefound=nil
    if Controls.read():start() then screen.waitVblankStart(10) break end
    screen.waitVblankStart()
    a=a+1
  end
  return -1
end